﻿var _USERINDEX=0;
var UserCollection={
	Users: new Array(),
	addUser: function (data) {
		_USERINDEX++;
		data.Index=_USERINDEX;
		var U=UserCollection.Users[data.UserKey];
		if(!U) {
			U=new User();
		}
		U.Index=data.Index;
		U.UserKey=data.UserKey;
		U.DisplayName=data.DisplayName;
		U.GroupName=data.GroupName;
		U.UserStatus=data.UserStatus;
		if(data.Gender=="0"||data.Gender=="M") {
			U.Gender="M";
		} else {
			U.Gender="F";
		}
		U.PersonalStatus=data.PersonalStatus;
		UserCollection.Users[data.UserKey]=U;
	},
	sort: function (groupname) {
		var sortUsers=new Array();
		for(var key in UserCollection.Users) {
			var u=UserCollection.Users[key];
			if(u) {
				if(u.GroupName==groupname) {
					sortUsers[sortUsers.length]={ DisplayName: u.DisplayName,UserKey: u.UserKey };
				}
			}
		}
		sortUsers.sort(function (a,b) {
			var aun=a.DisplayName;
			var bun=b.DisplayName;
			var i=aun>bun?1:-1;
			return i;
		});
		return sortUsers;
	},
	removeUser: function (key) {
		//delete UserCollection.Users[key];
	},
	checkUserExists: function (key) {
		if(key in UserCollection.Users) {
			return true;
		} else {
			return false;
		}
	},
	getUserByIndex: function (index) {
		var returnUser;
		for(var key in UserCollection.Users) {
			var u=UserCollection.Users[key];
			if(u.Index==index) {
				returnUser=u;
				break;
			}
		}
		return returnUser;
	},
	getUser: function (key) {
		return UserCollection.Users[key];
	},
	getUsers: function () {
		return UserCollection.Users;
	},
	getGroupUsers: function (groupName) {
		var users=new Array();
		for(var key in UserCollection.Users) {
			var u=UserCollection.Users[key];
			if(u.GroupName==groupName) {
				users[users.length]=u;
			}
		}
		return users;
	},
	getGroups: function () {
		var groups=new Array();
		for(var key in UserCollection.Users) {
			var u=UserCollection.Users[key];
			var groupExist=false;
			$.each(groups,function (i,g) {
				if(g==u.GroupName) {
					groupExist=true;
				}
			});
			if(groupExist==false) {
				if(u.GroupName!=undefined) {
					groups[groups.length]=u.GroupName;
				}
			}
		}
		groups.sort();
		return groups;
	},
	deleteAllUsers: function () {
		UserCollection.Users=new Array();
	},
	deleteAllUsersExceptMe: function () {
		for(var key in UserCollection.Users) {
			if(key!=WEBACTION.UserKey) {
				delete UserCollection.Users[key];
			}
		}
	}
}

var GroupCollection={
	GChat: new Array(),
	addUser: function (key,msg) {
		try {
			if(msg==undefined) {
				return;
			}
			var Users;
			if(GroupCollection.checkGroupExists(key)) {
				Users=GroupCollection.getGroup(key);
			} else {
				Users=new Array();
			}
			var amsg=msg.split(CONSTANTS.GChtUserDelim);
			for(var i=0;i<amsg.length;i++) {
				if(amsg[i]!=WEBACTION.UserKey) {
					if(this.userExist(Users,amsg[i])==false) {
						Users.push(amsg[i]);
					}
				}
			}
			GroupCollection.GChat[key]=Users;
		} catch(e) {
			//alert(e);
		}
	},
	userExist: function (users,userkey) {
		var i;var userExist=false;
		for(i=0;i<users.length;i++) {
			if(users[i]==userkey) { userExist=true; }
		}
		return userExist;
	},
	removeUser: function (key,user) {
		var Users;
		if(GroupCollection.checkGroupExists(key)) {
			Users=GroupCollection.getGroup(key);
			Users.splice(Users.indexOf(user),1);
			GroupCollection.GChat[key]=Users;
		}
	},
	removeGroup: function (key) {
		delete GroupCollection.GChat[key];
	},
	checkGroupExists: function (key) {
		if(key in GroupCollection.GChat) {
			return true;
		} else {
			return false;
		}
	},
	getGroup: function (key) {
		return GroupCollection.GChat[key];
	},
	getGroups: function () {
		return GroupCollection.GChat;
	},
	deleteAllGroups: function () {
		GroupCollection.GChat=new Array();
	}
}

function User() {
	this.Index=0;
	this.UserKey='';
	this.DisplayName='';
	this.GroupName='';
	this.UserStatus='';
	this.Gender='';
	this.PersonalStatus='';
}