﻿var WEBSOCKET={
	JQXHR: null,
	connectToServer: function () {
		var dt=new Date();
		var U='httpbinding';
		var param='key='+WEBACTION.EncKey+'&dt='+dt.getTime();
		//XMLHttpRequest
		WEBSOCKET.JQXHR=$.ajax({
			type: "get",
			dataType: "json",
			url: U,
			data: param,
			success: function (msg) {
				try {
					try {
						PROCESSWEBDATA.processData(msg);
					} catch(ex) {
					}
					if(WEBACTION.Connected) {
						WEBSOCKET.connectToServer();
					}
				} catch(e) {
					WEBSOCKET.connectToServer();
				}
			},
			error: function (message) {
				WEBSOCKET.connectToServer();
			}
		});
	},
	stopServer: function () {
		WEBSOCKET.JQXHR.abort();
	}
}

var PROCESSWEBDATA={
	processData: function (data) {
		var lpacket;
		switch(data.Type) {
			case "Chat":
				WEBACTION.displayChatMessage(data.From,data.Message,data.From);
				break;
			case "User":
				UserCollection.addUser(data);
				WEBACTION.displayUser(data);
				break;
			case "Logout":
				if(data.From=="") break;
				if(data.From=="S"||data.From==WEBACTION.UserKey) {
					alert("You have signed in from another location.");
					WEBACTION.logout(true);
				} else {
					var u=UserCollection.getUser(data.From);
					if(u) {
						u.GroupName="Offline Users";
						var cw=$("#chat-window-"+u.Index);
						if(cw.get(0)) {
							var msg='<li class="loggedoff" logoff="'+u.DisplayName+'">-----&nbsp;'+u.DisplayName+'&nbsp;Logged Off&nbsp;:&nbsp;'+getTime(false)+'&nbsp;------</li>';
							var d={ "FromName": u.UserKey,"Message": msg,"ME": false };
							d.DisplayName=u.DisplayName;
							var content=$("div[data-role='content']",cw);
							WEBACTION.appendMessage(content,d,"usermessagetemplate");
						}
						try {
							for(key in GroupCollection.GChat) {
								var users=GroupCollection.GChat[key];
								var isUserExist=false;
								var gcarr=new Array();
								$.each(users,function (i,user) {
									var guser=UserCollection.getUser(user);
									if(guser) {
										if(guser.UserKey==u.UserKey) {
											isUserExist=true;
											gcarr[gcarr.length]=key;
										}
									}
								});
								$.each(gcarr,function (j,gckey) {
									var gcw=$("div[gcwkey='"+gckey+"']").get(0);
									if(gcw) {
										var msg='<li class="loggedoff" logoff="'+u.DisplayName+'">-----&nbsp;'+u.DisplayName+'&nbsp;Logged Off&nbsp;:&nbsp;'+getTime(false)+'&nbsp;------</li>';
										var d={ "FromName": u.UserKey,"Message": msg,"ME": false };
										d.DisplayName=u.DisplayName;
										var content=$("div[data-role='content']",gcw);
										WEBACTION.appendMessage(content,d,"usermessagetemplate");
									}
								});
							}
						} catch(e) {
							//	alert(e);
						}
					}
					WEBACTION.clearSelectUser(data.From);
				}
				break;
			case "GroupChat":
				WEBACTION.displayChatMessage(data.From,data.Message,data.GroupKey);
				break;
			case "GroupChatInvite":
				try {
					//data1=Users;2=FromUser;3=GroupKey
					GroupCollection.addUser(data.GroupKey,data.Message);
					var gcusers=data.Message.split(CONSTANTS.GChtUserDelim);
					var flag;
					for(var i=0;i<gcusers.length;i++) {
						if(gcusers[i]!=WEBACTION.UserKey) {
							WEBACTION.sendMessage(LSTYPE.GroupUserAdd,gcusers[i],"",data.GroupKey);
						}
					}
				} catch(e) {
					alert("GroupChatInvite:"+e);
				}
				break;
			case "GroupUserAdd":
				if(data.From!=WEBACTION.UserKey) {
					GroupCollection.addUser(data.GroupKey,data.From);
				}
				var gcusers=GroupCollection.getGroup(data.GroupKey);
				var users=WEBACTION.getDisplayName(WEBACTION.UserKey);
				$.each(gcusers,function (i,gcuser) {
					var u=UserCollection.getUser(gcuser);
					if(u) {
						users+=","+u.DisplayName;
					}
				});
				var gcw=$("div[gcwkey='"+data.GroupKey+"']").get(0);
				if(gcw) {
					$("#gcusernames .ui-btn-text",gcw).html(users);
				}
				break;
			case "GroupUserRemove":
				try {
					var $gcw=$("div[gcwkey='"+data.GroupKey+"']");
					if(data.From==WEBACTION.UserKey) {
						if($gcw.get(0)) {
							$gcw.attr("isclose","true");
							$("#incomingMessages",$gcw).empty();
							WEBACTION.changeCWCount();
							WEBACTION.backOM();
						}
					} else {
						var u=UserCollection.getUser(data.From);
						if(u) {
							var msg='<li class="message lc">-----&nbsp;'+u.DisplayName+'&nbsp;has left the chat&nbsp;-----</li>';
							var d={ "FromName": u.UserKey,"Message": msg,"ME": false };
							d.DisplayName=u.DisplayName;
							var content=$("div[data-role='content']",$gcw);
							WEBACTION.appendMessage(content,d,"usermessagetemplate");
						}
					}
					GroupCollection.removeUser(data.GroupKey,data.From);
					if(data.From==WEBACTION.UserKey) { //Remove current user
						GroupCollection.removeGroup(data.GroupKey);
					}
				} catch(ex) {
					alert("GroupUserRemove:"+ex);
				}
				break;
			case "ChangeName":
				WEBACTION.changeDisplayName(data.From,data.Message);
				break;
			case "ChangeGroup":
				WEBACTION.changeGroupName(data.From,data.Message);
				break;
			case "ChangeStatus":
				WEBACTION.changeStatus(data.From,data.Message);
				break;
			case "ChangePersonalStatus":
				WEBACTION.changePersonalStatus(data.From,data.Message);
				break;
			case "Announcement":
				WEBACTION.displayChatMessage(data.From,data.Message,"ANN",data.ReceivedDate);
				break;
			case "Mail":
				WEBACTION.displayChatMessage(data.From,data.Message,"MAIL",data.Subject);
				break;
			case "OfflineMessage":
				WEBACTION.displayChatMessage(data.From,data.Message,"OFF");
				break;
			case "OfflineAnnouncement":
				WEBACTION.displayChatMessage(data.From,data.Message,"OFFANN",data.ReceivedDate);
				break;
			case "OfflineMail":
				WEBACTION.displayChatMessage(data.From,data.Message,"OFFMAIL",data.Subject);
				break;
			case "Buzz":
				WEBACTION.displayChatMessage(data.From,"BUZZ!",data.From);
				break;
		}

	}
}
 