﻿var _sendMessageUrl="SendMessage.aspx";
var _idleTime=(1000*180);
var _is_Idle=false;
var _sortMode="SORTGROUPS";
var _chatWindowIndex=0;
var _addGCWindowIndex=0;
var _gcWindowIndex=0;
var _otherWindowIndex=0;
var CONSTANTS={
	SEP: '^',
	CmdSep: '<D<',
	EOM: ';',
	GChtUserDelim: ',',
	LF: '\n'
}
var LSTYPE={
	Chat: 0
	,GroupChat: 1
	,GroupChatInvite: 2
	,GroupUserAdd: 3
	,GroupUserRemove: 4
	,Announcement: 5
	,Mail: 6
	,OfflineAnnouncement: 7
	,OfflineMail: 8
	,OfflineMessage: 9
	,Logout: 10
	,ChangeStatus: 11
	,ChangePersonalStatus: 12
	,ChangeGroup: 13
	,ChangeName: 14
	,Buzz: 15
	,NoOperation: 16
	,OfflineUsers: 101
	,OnlineUsers: 102
	,SendGCMessage: 103
	,SendGCInvite: 104
	,ProfileImage: 105
}



$(document).bind("pagebeforechange",function (e,data) {
	if(typeof data.toPage==="string") {

		WEBACTION.showLoading();

		var u=$.mobile.path.parseUrl(data.toPage),
					re=/^#chat-window/;

		if(u.hash.search(re)!== -1) {
			var index=u.hash.replace(/.*index=/,"");
			var options=data.options;
			WEBACTION.chat(index,false);
			e.preventDefault();
		}
	}
});

$(document).bind("pagechange",function (event,ui) {
	try {
		setTimeout(function () {
			WEBACTION.hideLoading();
		},1000);
		var $page=$.mobile.activePage;
		$page.attr("isnewmessage","false");
		$("div[isnew='true']",$page).attr("isnew","false");
		WEBACTION.changeCWCount();
		WEBACTION.displayNewMessageCnt($page);
	} catch(e) {
	}
});

$(document).bind("pagebeforehide",function (e,ui) {
	WEBACTION.changeCWCount();
});

var WEBACTION={
	pageInit: false
	,lastTitle: ""
	,init: function () {
		OMTEMPLATE.init();
		WEBACTION.refreshGroupCount();
		WEBACTION.Connected=true;
		WEBSOCKET.connectToServer();
		WEBACTION.linkToLS();
		WEBACTION.showLoading("Loading...");
		setTimeout(function () {
			WEBACTION.hideLoading();
		},1000);
	}
	,EncKey: ''
	,ToId: ''
	,UserKey: ''
	,isRefresh: false
	,Connected: false
	,showChatWindow: function (chatwindow) {
		var userbox=$("#UserBox");
		var chatbox=$("#ChatBox");
		userbox.hide();
		chatbox.show();
		chatwindow.show();
	}
	,showLoading: function (msg) {
		if(msg==undefined) {
			msg="";
		}
		if($.trim(msg)=="") {
			msg="Loading...";
		}
		var OMLoading=$("#OMLoading");
		if(!OMLoading.get(0)) {
			var data=[{ "Message": msg}];
			$.tmpl("loadingmessagetemplate",data).appendTo($("body"));
			OMLoading=$("#OMLoading");
		}
		$("h1",OMLoading).html(msg);
		OMLoading.show();
		var windowWidth=$(window).width();
		var windowHeight=$(window).height();
		var width=OMLoading.width();
		var height=OMLoading.height();
		var left=(windowWidth/2)-(width/2);
		var top=(windowHeight/2)-(height/2);
		OMLoading.css("top",top);
	}
	,hideLoading: function () {
		$("#OMLoading").hide();
	}
	,getChatWindowIndex: function () {
		_chatWindowIndex++;
		return _chatWindowIndex;
	}
	,backOM: function () {
		var $page=$("#OM");
		$.mobile.changePage($page);
	}
	,chat: function (index,notOpen) {
		var cw=$("#chat-window-"+index).get(0);
		var cwid="chat-window-"+index;
		var isNew=false;
		var user=UserCollection.getUserByIndex(index);
		cwid=cwid.replace("#","");
		if(cw) {
			cwid=$(cw).attr("id");
		} else {
			var div=document.createElement("div");
			user.IsGC=false;
			$.tmpl("chatboxtemplate",user).appendTo(div);
			//$("#chatboxtemplate").tmpl(user).appendTo(div);
			var markup=$(div).html();
			$("body")
			.append(markup);
		}
		var $page=$("#"+cwid),
		$header=$page.children(":jqmData(role=header)"),
		$content=$page.children(":jqmData(role=content)");

		var msgContainerDiv=$("div[data-role='content']",$page);

		var h=$(window).height()-240;
		var sty=msgContainerDiv.attr("style");
		if(!sty) {
			msgContainerDiv.css("height",h);
		}
		var gcusers=$("#gcusers",$page).get(0);
		if(gcusers) {
			$(gcusers)
			.unbind("change")
			.change(function () {
				var selectedArray=new Array();
				var selObj=this;
				var i;
				var count=0;
				for(i=0;i<selObj.options.length;i++) {
					if(selObj.options[i].selected) {
						selectedArray[count]=selObj.options[i].value;
						count++;
					}
				}
			});
			gcusers.options.length=null;
			var listItem=new Option("Group Chat","",false,false);
			gcusers.options[gcusers.options.length]=listItem;
			for(var key in UserCollection.Users) {
				var u=UserCollection.Users[key];
				if(u) {
					if(u.GroupName!="Offline Users"&&((u.UserKey!=user.UserKey)==true)&&((u.UserKey!=WEBACTION.UserKey)==true)) {
						listItem=new Option(u.DisplayName,u.UserKey,false,false);
						gcusers.options[gcusers.options.length]=listItem;
					}
				}
			}

			if(gcusers.options.length==1) {
				$(gcusers).hide();
			} else {
				$(gcusers).show();
			}
		}

		$page
		.attr("isclose","false")
		.page();

		var dataurl="#chat-window-"+index+"?index="+index;
		if(notOpen==false) {
			WEBACTION.changePage($page,dataurl);
		}
	}
	,setOptions: function ($page) {
		var options=$("#options",$page);
		options
		.val("")
		.unbind("change")
		.change(function () {
			switch(this.value) {
				case "close":
					$page.attr("isclose","true");
					if($page.attr("type")=="gcusers") {
						var gcwkey=$page.attr("gcwkey");
						WEBACTION.sendRemovGC(gcwkey,WEBACTION.UserKey+"|");
					}
					$("div[data-role='content'] .msg-container",$page).empty();
					WEBACTION.changeCWCount();
					WEBACTION.backOM();
					break;
				case "groupchat":
					var id=$page.attr("id");
					var cwindex=$page.attr("cwindex");
					var param="";
					if(cwindex!="") {
						param+="?index="+cwindex;
					}
					var currentUserKey=$(":input[name='touser']",$page).val();
					WEBACTION.addGC(id,param,"",currentUserKey);
					break;
				case "adduser":
					var id=$page.attr("id");
					var cwindex=$page.attr("cwindex");
					if(cwindex!="") {
						id+="?index="+cwindex;
					}
					WEBACTION.addGC(id,"","adduser","");
					break;
				case "removeuser":
					var id=$page.attr("id");
					var cwindex=$page.attr("cwindex");
					if(cwindex!="") {
						id+="?index="+cwindex;
					}
					WEBACTION.addGC(id,"","removeuser","");
					break;
			}
		});
		try {
			options.selectmenu('refresh',true);
		} catch(e) {
		}
	}
	,backToCW: function (id) {
		var $page=$("#"+id);
		WEBACTION.setOptions($page);
		$.mobile.changePage($page);
	}
	,changePage: function ($page,dataurl) {
		WEBACTION.setOptions($page);
		var activePage=$(".ui-page-active");
		if(activePage.attr("id")==$page.attr("id")) {
			$page.attr("isnewmessage","false");
		}

		$page.attr("isnewmessage","false");
		$.mobile.changePage($page,{ dataUrl: dataurl });
		//$("#message",$page).focus();
		$("div[isnew='true']",$page).attr("isnew","false");
		var content=$("div[data-role='content']",$page);
		setTimeout(function () {
			var msgcontainer=$(".msg-container",content);
			WEBACTION.scrollObj(msgcontainer);
		},500);
		WEBACTION.changeCWCount();
	}
	,closeCW: function (index) {
		var cw=$("#chat-window-"+index);
		cw.attr("isclose","true");
		$("div[data-role='content'] .msg-container",cw).empty();
		WEBACTION.changeCWCount();
		WEBACTION.backOM();
	}
	,closeGCW: function (index) {
		var cw=$("#group-chat-window-"+index);
		cw.attr("isclose","true");
		$("div[data-role='content'] .msg-container",cw).empty();
		WEBACTION.changeCWCount();
		WEBACTION.backOM();
	}
	,closeOW: function (index) {
		var cw=$("#other-window-"+index);
		cw.attr("isclose","true");
		$("div[data-role='content']",cw).empty();
		WEBACTION.changeCWCount();
		WEBACTION.backOM();
	}
	,changeCWCount: function () {
		var cnt=$(".chat-window[isnewmessage='true']").length;
		$(".cwcnt")
		.each(function () {
			if(cnt>0) {
				$(this).show();
			} else {
				$(this).hide();
			}
			$("span",this).html(cnt);
		});
	}
	,openCW: function () {
		var cw=$("#chat-window-list").get(0);
		var $page=$("#chat-window-list");
		var $content=$page.children(":jqmData(role=content)");
		var listview=$content.children(":jqmData(role=listview)");
		var cwid="";
		var cwname="";
		var html="";
		var type="";
		var fromname="";
		listview.empty();
		var html="<li data-role='list-divider' chatwindowname='users'>Users<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='groupchats'>Group Chats<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='announcements'>Announcements<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='mails'>Mails<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='offlinemessages'>Offline Messages<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='offlineannouncements'>Offline Announcements<span class='ui-li-count'></span></li>";
		html+="<li data-role='list-divider' chatwindowname='offlinemails'>Offline Mails<span class='ui-li-count'></span></li>";
		listview.html(html);
		var usersgroup=$("li[chatwindowname='users']",listview);
		$(".chat-window[isclose='false']").each(function () {
			cwid=$(this).attr("id");
			cwname=$("h1",this).html();
			type=$(this).attr("type");
			fromname=$(this).attr("fromname");
			switch(type) {
				case "users":
					usersgroup=$("li[chatwindowname='users']",listview);
					var touser=$(":input[name='touser']",this).val();
					var user=UserCollection.getUser(touser);
					if(user) {
						if(user.GroupName!="Offline Users") {
							$.tmpl("chatwindowusertemplate",user).insertAfter(usersgroup);
							//$("#chatwindowusertemplate").tmpl(user).insertAfter(usersgroup);
						}
					}
					break;
				case "gcusers":
					usersgroup=$("li[chatwindowname='groupchats']",listview);
					var data={ gcid: cwid };
					$.tmpl("groupchatwindowusertemplate",data).insertAfter(usersgroup);
					//$("#groupchatwindowusertemplate").tmpl(data).insertAfter(usersgroup);
					break;
				case "ANN":
				case "MAIL":
				case "OFF":
				case "OFFANN":
				case "OFFMAIL":
					var cwname="";
					var name="";
					switch(type) {
						case "ANN":
							cwname="announcements";
							name="Announcements";
							break;
						case "MAIL":
							cwname="mails";
							name="Mails";
							break;
						case "OFF":
							cwname="offlinemessages";
							name="Offline Messages";
							break;
						case "OFFANN":
							cwname="offlineannouncements";
							name="Offline Announcements";
							break;
						case "OFFMAIL":
							cwname="offlinemails";
							name="Offline Mails";
							break;
					}
					usersgroup=$("li[chatwindowname='"+cwname+"']",listview);
					if(fromname!="") {
						name+=" - "+fromname;
					}
					var data={ id: cwid,Name: name,Type: cwname };
					$.tmpl("otherwindowusertemplate",data).insertAfter(usersgroup);
					//$("#otherwindowusertemplate").tmpl(data).insertAfter(usersgroup);
					break;
			}
		});
		$("li[chatwindowname]",listview).each(function () {
			var type=$(this).attr("chatwindowname");
			var cnt=$("li[type='"+type+"']",listview).length;
			$(".ui-li-count",this).html(cnt);
			if(cnt>0) {
				$(this).show();
			} else {
				$(this).hide();
			}
		});
		$.mobile.changePage($page);
		listview.listview("refresh");
	}
	,send: function (btn) {
		try {
			var div=$(btn).parents(".chat-window:first");
			var params=new Array();
			var type=$(":input[name='type']",div).val();
			$(":input",div).each(function () {
				params[params.length]={ "name": $(this).attr("name"),"value": this.value };
			});
			var gcwkey=div.attr("gcwkey");
			if(gcwkey!="") {
				var gcusers=GroupCollection.getGroup(gcwkey);
				var users="";
				$.each(gcusers,function (i,gcuser) {
					users+=gcuser+CONSTANTS.GChtUserDelim;
				});
				params[params.length]={ "name": "users","value": users };
			}
			var msgtxt;
			if(type==LSTYPE.OfflineMessage) {
				msgtxt=$("#m",div);
			} else {
				msgtxt=$("#message",div);
			}
			var msg=msgtxt.val();
			if($.trim(msg)!="") {
				msgtxt.val("");
				var data={ "FromName": WEBACTION.UserKey,"Message": msg,"ME": true };
				data.DisplayName=WEBACTION.getDisplayName(WEBACTION.UserKey);
				var content=$("div[data-role='content']",div);
				WEBACTION.appendMessage(content,data,"usermessagetemplate");
				$.post(_sendMessageUrl,params);
			}
			if(type==LSTYPE.OfflineMessage) {
				WEBACTION.backOM();
			} else {
				//msgtxt.focus();
				var content=$("div[data-role='content']",div);
				var msgcontainer=$(".msg-container",content);
				WEBACTION.scrollObj(msgcontainer);
			}
		} catch(e) {
			alert("send:"+e);
		}
		return false;
	}
	,addGC: function (pageID,param,mode,currentUserKey) {
		try {
			_addGCWindowIndex++;
			var groups=new Array();
			var users=new Array();
			var $backpage=$("#"+pageID);
			var isGCWindow=false;
			var ischecked=false;
			var gcwkey="";
			if($backpage.get(0)) {
				gcwkey=$backpage.attr("gcwkey");
				if(gcwkey!=""&&mode=="removeuser") {
					isGCWindow=true;
				}
			}
			var g=GroupCollection.getGroup(gcwkey);
			if(isGCWindow==false) {
				for(var key in UserCollection.Users) {
					var u=UserCollection.Users[key];
					if(u) {
						if(u.GroupName!="Offline Users"
						&&((u.UserKey!=WEBACTION.UserKey)==true)
						) {
							ischecked=false;
							if(g) {
								ischecked=GroupCollection.userExist(g,u.UserKey);
							}
							if(mode=="") {
								if(u.UserKey==currentUserKey) {
									ischecked=true;
								}
							}
							WEBACTION.addGCGroup(groups,u.GroupName);
							users[users.length]={ "DisplayName": u.DisplayName,"UserKey": u.UserKey,"IsChecked": ischecked,"GroupName": u.GroupName };
						}
					}
				}
			} else {
				if(g) {
					for(var i=0;i<g.length;i++) {
						if(g[i]!=WEBACTION.UserKey) {
							var u=UserCollection.getUser(g[i]);
							if(u) {
								ischecked=false;
								if(g) {
									ischecked=GroupCollection.userExist(g,u.UserKey);
								}
								WEBACTION.addGCGroup(groups,u.GroupName);
								users[users.length]={ "DisplayName": u.DisplayName,"UserKey": u.UserKey,"IsChecked": ischecked,"GroupName": u.GroupName };
							}
						}
					}
				}
			}
			var groupsData=new Array();
			var checkUserCount=0;
			var usersCount=0;
			$.each(groups,function (i,g) {
				checkUserCount=0;
				usersCount=0;
				$.each(users,function (j,u) {
					if(g==u.GroupName) {
						if(u.IsChecked==true) {
							checkUserCount++;
						}
						usersCount++;
					}
				});
				var gd={ "GroupName": g,"IsChecked": false };
				if((checkUserCount==usersCount)&&(checkUserCount>0)) {
					gd.IsChecked=true;
				}
				groupsData[groupsData.length]=gd;
			});
			var data={ "Index": _addGCWindowIndex,"Groups": groupsData,"Users": users,"Back": pageID,"Param": param,"IsGC": isGCWindow,"Mode": mode };
			var $bdy=$("body");
			$.tmpl("addgroupchattemplate",data).appendTo($bdy);
			//$("#addgroupchattemplate").tmpl(data).appendTo($bdy);
			var id="addgroupchat_"+_addGCWindowIndex;
			var $page=$("#"+id);
			$.mobile.changePage($page,{ dataUrl: "addgroupchat" });
		} catch(e) {
			alert("addGC:"+e);
		}
	}
	,selectGC: function (that) {
		var isChecked=that.checked;
		var gname=that.value;
		var li=$(that).parents("ul:first");
		$(":input",li)
		.each(function () {
			if((this.id.indexOf("checkbox-1a")> -1)&&$(this).attr("gname")==gname) {
				$(this).attr("checked",isChecked).checkboxradio("refresh");
			}
		});
	}
	,addGCGroup: function (groups,groupName) {
		var isAlreadyExist=false;
		$.each(groups,function (i,g) {
			if(g==groupName) {
				isAlreadyExist=true;
			}
		});
		if(isAlreadyExist==false) {
			groups[groups.length]=groupName;
		}
	}
	,openOffWindow: function (touserkey) {
		var $page=$("#offline-window");
		var touser=UserCollection.getUser(touserkey);
		if(touser) {
			$("#tousername",$page).html(touser.DisplayName);
			$("#m",$page).val("");
			$(":input[name='sessionkey']",$page).val(WEBACTION.EncKey);
			$(":input[name='tousers']",$page).val(touser.UserKey);
			$(":input[name='type']",$page).val(LSTYPE.OfflineMessage);
			WEBACTION.changePage($page,"offline-window");
		}
	}
	,sendMessage: function (type,dest,message,gckey) {
		try {
			if(gckey==undefined) gckey='';
			var param=new Array();
			if(message=="BUZZ!") { type=LSTYPE.Buzz; }
			param[param.length]={ "name": "type","value": type };
			param[param.length]={ "name": "touser","value": dest };
			param[param.length]={ "name": "groupchatkey","value": gckey };
			param[param.length]={ "name": "sessionkey","value": WEBACTION.EncKey };
			param[param.length]={ "name": "message","value": message };
			$.post(_sendMessageUrl,param);
		} catch(e) {
			alert("sendMessage:"+e);
		}
	}
	,createGC: function (id) {
		var dt=new Date;
		var minutes=dt.getMinutes();
		var hour=dt.getHours();
		var sec=dt.getSeconds();
		var key=WEBACTION.UserKey+minutes+hour+sec;
		var addgc=$("#"+id);
		var users=new Array();
		$("input:checked",addgc)
		.each(function () {
			var u=UserCollection.getUser(this.value);
			if(u) {
				users[users.length]={ "UserKey": u.UserKey,"DisplayName": u.DisplayName };
				GroupCollection.addUser(key,u.UserKey);
			}
		});
		var j;
		var sendMessages=new Array();
		var sendUserKey="";var z;
		for(j=0;j<users.length;j++) {
			sendMessages[sendMessages.length]={ "To": users[j].UserKey,"UserIds": WEBACTION.getGCUsers(users[j],users,(j+1)) };
		}
		var s="";var gcinviteusers="";var k;var z;
		for(k=0;k<users.length;k++) {
			var u=users[k];
			for(z=0;z<sendMessages.length;z++) {
				if(sendMessages[z].To==u.UserKey) {
					gcinviteusers+=sendMessages[z].To+"~"+sendMessages[z].UserIds+"|";
				}
			}
		}
		var arr=gcinviteusers.split("|");
		var i;var log="";
		for(i=0;i<arr.length;i++) {
			var toarr=arr[i].split("~");
			if(toarr.length>=2) {
				var j;
				log+="ToUser:"+WEBACTION.getDisplayName(toarr[0])+"\n";
				var uarr=toarr[1].split(",");
				for(j=0;j<uarr.length;j++) {
					log+="User:"+WEBACTION.getDisplayName(uarr[j])+"\n";
				}
			}
		}
		//alert(log);
		if(gcinviteusers=="") {
			alert("Select any one user");
		} else {
			var $gcw=WEBACTION.createGCWindow(key);
			WEBACTION.setOptions($gcw);
			$.mobile.changePage($gcw);
			var url=_sendMessageUrl;
			var param=new Array();
			param[param.length]={ "name": "type","value": LSTYPE.SendGCInvite };
			param[param.length]={ "name": "users","value": gcinviteusers };
			param[param.length]={ "name": "gckey","value": key };
			param[param.length]={ "name": "sessionkey","value": WEBACTION.EncKey };
			$.post(url,param);
			WEBACTION.changeCWCount();
		}
	}
	,updateGC: function (id,gcwid) {
		var addgc=$("#"+id);
		var $gcw=$("#"+gcwid);
		var gcwkey=$gcw.attr("gcwkey");
		var mode=$(":input[name='mode']",addgc).val();
		var removeUsers="";
		var addUsers="";
		var groupusers=GroupCollection.getGroup(gcwkey);
		$(":input[type='checkbox']",addgc)
		.each(function () {
			var u=UserCollection.getUser(this.value);
			if(u) {
				var isUserExist=false;
				if(groupusers) {
					isUserExist=GroupCollection.userExist(groupusers,u.UserKey);
				}
				if(this.checked==true) {
					if(isUserExist==false) {
						GroupCollection.addUser(gcwkey,u.UserKey);
						addUsers+=u.UserKey+"|";
					}
				} else {
					if(isUserExist) {
						GroupCollection.removeUser(gcwkey,u.UserKey);
						removeUsers+=u.UserKey+"|";
					}
				}
			}
		});
		$(":input[name='users']",$gcw).remove();
		var gcusernames=WEBACTION.getDisplayName(WEBACTION.UserKey);
		var g=GroupCollection.getGroup(gcwkey);
		if(g) {
			for(var i=0;i<g.length;i++) {
				if(g[i]!=WEBACTION.UserKey) {
					var u=UserCollection.getUser(g[i]);
					if(u) {
						gcusernames+=","+u.DisplayName;
					}
				}
			}
		}
		WEBACTION.sendAddGC(gcwkey,addUsers);
		WEBACTION.sendRemovGC(gcwkey,removeUsers);
		$("#gcusernames .ui-btn-text",$gcw).html(gcusernames);
		WEBACTION.setOptions($gcw);
		$.mobile.changePage($gcw,{ dataUrl: gcwid });
	}
	,sendAddGC: function (gckey,newUsers) {
		try {
			var gcusers=GroupCollection.getGroup(gckey);
			var gcinviteusers="";
			var arr=newUsers.split("|");
			$.each(arr,function (i,nu) {
				var u=UserCollection.getUser(nu);
				if(u) {
					if(u.UserKey!=WEBACTION.UserKey) {
						var userids=WEBACTION.UserKey;
						for(i=0;i<gcusers.length;i++) {
							userids+=CONSTANTS.GChtUserDelim+gcusers[i];
						}
						gcinviteusers+=u.UserKey+"~"+userids+"|";
					}
				}
			});
			if(gcinviteusers!="") {
				var url=_sendMessageUrl;
				var param=new Array();
				param[param.length]={ "name": "type","value": LSTYPE.SendGCInvite };
				param[param.length]={ "name": "users","value": gcinviteusers };
				param[param.length]={ "name": "gckey","value": gckey };
				param[param.length]={ "name": "sessionkey","value": WEBACTION.EncKey };
				$.post(url,param);
			}
		} catch(ex) {
			alert("sendAddGC:"+ex);
		}
	}
	,sendRemovGC: function (gckey,removeUsers) {
		var users="";
		for(var key in UserCollection.Users) {
			var u=UserCollection.Users[key];
			if(u) {
				if(u.UserKey!=WEBACTION.UserKey) {
					users+=u.UserKey+"|";
				}
			}
		}
		if(removeUsers!="") {
			var url=_sendMessageUrl;
			var param=new Array();
			param[param.length]={ "name": "type","value": LSTYPE.GroupUserRemove };
			param[param.length]={ "name": "users","value": users };
			param[param.length]={ "name": "removeusers","value": removeUsers };
			param[param.length]={ "name": "gckey","value": gckey };
			param[param.length]={ "name": "sessionkey","value": WEBACTION.EncKey };
			$.post(url,param);
		}
	}
	,createGCWindow: function (key) {
		try {
			var gcw=$("div[gcwkey='"+key+"']");
			if(!gcw.get(0)) {
				_gcWindowIndex++;
				var users=new Array();
				var g=GroupCollection.getGroup(key);
				if(g) {
					for(var i=0;i<g.length;i++) {
						if(g[i]!=WEBACTION.UserKey) {
							var u=UserCollection.getUser(g[i]);
							if(u) {
								users[users.length]={ "UserKey": u.UserKey,"DisplayName": u.DisplayName };
							}
						}
					}
				}
				var div=document.createElement("div");
				var data={ "IsGC": true,"GroupUsers": users,"Index": _gcWindowIndex,"UserKey": key,"DisplayName": "Group Chat","GroupName": "","UserStatus": "","Gender": "","PersonalStatus": "" };
				var bdy=$("body");
				$.tmpl("chatboxtemplate",data).appendTo(bdy);
				//$("#chatboxtemplate").tmpl(data).appendTo(bdy);
				var $gcw=$("#group-chat-window-"+_gcWindowIndex);
				var msgContainerDiv=$("div[data-role='content']",$gcw);

				var h=$(window).height()-210;
				var sty=msgContainerDiv.attr("style");
				if(!sty) {
					msgContainerDiv.css("height",h);
				}
				return $gcw;
			} else {
				return gcw;
			}
		} catch(e) {
			alert("createGCWindow:"+e);
		}
	}
	,getGCUsers: function (sendUserKey,users,rounds) {
		var m="";var log="";
		m+=WEBACTION.UserKey;
		log+=WEBACTION.getDisplayName(WEBACTION.UserKey);
		for(j=0;j<rounds;j++) {
			m+=CONSTANTS.GChtUserDelim+users[j].UserKey;
			log+=CONSTANTS.GChtUserDelim+WEBACTION.getDisplayName(users[j].UserKey);
		}
		return m;
	}
	,linkToLS: function () {
		setInterval(function () {
			var param=new Array();
			param[param.length]={ "name": "type","value": LSTYPE.NoOperation };
			param[param.length]={ "name": "sessionkey","value": WEBACTION.EncKey };
			$.post(_sendMessageUrl,param);
		},(1000*30)); // One minute
	}
	,getOnlineUsers: function () {
		//WEBACTION.getUsers(LSTYPE.OnlineUsers);
	}
	,getOfflineUsers: function () {
		//WEBACTION.getUsers(LSTYPE.OfflineUsers);
	}
	,getUsers: function (type) {
		var url=_sendMessageUrl+"?type="+type+"&sessionkey="+WEBACTION.EncKey;
		$.getJSON(url,function (data) {
			$.each(data,function (i,user) {
				if(type==LSTYPE.OfflineUsers) {
					user.GroupName="Offline Users";
				}
				UserCollection.addUser(user);
			});
			var sortGroups=UserCollection.getGroups();
			$.each(sortGroups,function (j,group) {
				var sortUsers=UserCollection.sort(group);
				for(var i=sortUsers.length-1;i>=0;i--) {
					var omuser=UserCollection.Users[sortUsers[i].UserKey];
					if(omuser) {
						WEBACTION.displayUser(omuser);
					}
				}
			});
			if(WEBACTION.pageInit==false) {
				WEBACTION.pageInit=true;
				WEBACTION.getOfflineUsers();
			}
		});
		WEBACTION.Connected=true;
		if(type!=LSTYPE.OfflineUsers) {
			WEBSOCKET.connectToServer();
		}
	}
	,displayUser: function (user) {
		if(!user.UserKey) return;
		user.SessionKey=WEBACTION.EncKey;
		var chat_list=$(".chat_list");
		if(user.UserKey!=WEBACTION.UserKey) {
			var g=WEBACTION.addGroup(chat_list,user);
			if(g) {
				var users;
				users=chat_list;
				var userli=WEBACTION.getUserLI(user.UserKey);
				userli.remove();
				$.tmpl("usertemplate",user).insertAfter(g);
				//$("#usertemplate").tmpl(user).insertAfter(g);
			}
		}
		WEBACTION.refreshGroupCount();
		chat_list.listview("refresh");
	}
	,refreshGroupCount: function () {
		$("li[data-role='list-divider']").each(function () {
			var gname=$(this).attr("gcname");
			var cnt=$(".user_detail[usergroupname='"+gname+"']").length;
			if(cnt<=0) {
				$(this).remove();
			} else {
				$(".ui-li-count",this).html(cnt);
			}
		});
	}
	,addGroup: function (chatlist,data) {
		var gname=data.GroupName;
		var g=WEBACTION.getGroupBox(gname,chatlist).get(0);
		if(!g) {
			var cnt=$("li",chatlist).length;
			var firstli=WEBACTION.getGroupBox("Offline Users",chatlist);
			var offlineGroupExist=false;
			if(!firstli.get(0)) {
				firstli=$("li:first",chatlist);
			} else {
				offlineGroupExist=true;
			}
			var lastli=$("li:last",chatlist);
			if(data.GroupName=="Offline Users") {
				if(cnt<=0) {
					$.tmpl("grouptemplate",data).appendTo(chatlist);
					//$("#grouptemplate").tmpl(data).appendTo(chatlist);
				} else {
					$.tmpl("grouptemplate",data).insertAfter(lastli);
					//$("#grouptemplate").tmpl(data).insertAfter(lastli);
				}
			} else {
				if(cnt<=0) {
					$.tmpl("grouptemplate",data).appendTo(chatlist);
					//$("#grouptemplate").tmpl(data).appendTo(chatlist);
				} else {
					if(offlineGroupExist==true) {
						$.tmpl("grouptemplate",data).insertBefore(firstli);
						//$("#grouptemplate").tmpl(data).insertBefore(firstli);
					} else {
						$.tmpl("grouptemplate",data).insertAfter(firstli);
						//$("#grouptemplate").tmpl(data).insertAfter(firstli);
					}
				}
			}
			g=WEBACTION.getGroupBox(data.GroupName,chatlist).get(0);
		}
		return g;
	}
	,logout: function (sendtols) {
		WEBACTION.Connected=false;
		if(sendtols) {
			location.href="Logout.aspx?sessionkey="+WEBACTION.EncKey;
		}
	}
	,getTabBox: function (gcname,target) {
		if(target) {
			if(!($(target).get(0))) {
				target=$("body");
			}
		}
		return $("div[tabkey='"+gcname+"']",target);
	}
	,getGroupBox: function (gcname,target) {
		if(target) {
			if(!($(target).get(0))) {
				target=$("body");
			}
		}
		return $("li[gcname='"+gcname.toLowerCase()+"']",target);
	}
	,getGCGroupWindow: function (gcname,target) {
		if(target) {
			if(!($(target).get(0))) {
				target=$("body");
			}
		}
		return $("ul[gcgroupname='"+gcname.toLowerCase()+"']",target);
	}
	,getGCUserBox: function (key,target) {
		if(target) {
			if(!($(target).get(0))) {
				target=$("body");
			}
		}
		return $("li[gcuserkey='"+key+"']",target);
	}
	,getUserLI: function (key,target) {
		if(target) {
			if(!($(target).get(0))) {
				target=$("body");
			}
		}
		return $("li[liuserkey='"+key+"']",target);
	}
	,displayChatMessage: function (fromuserkey,msg,key,advalue) {
		try {
			var data=WEBACTION.getCWDataObject();
			var tkey=(new Date).getTime();
			data.FromName=fromuserkey;
			data.DisplayName=WEBACTION.getDisplayName(fromuserkey);
			data.Title=data.DisplayName;
			data.Key=key;
			data.ToName=WEBACTION.UserKey;
			data.Message=msg;
			data.Mode=key;
			switch(key) {
				case "ANN":
					data.Key=WEBACTION.UserKey+"_"+tkey;
					data.ISANN=true;
					data.Title="Announcement";
					data.ReceivedDate=advalue;
					break;
				case "MAIL":
					data.Key=WEBACTION.UserKey+"_"+tkey;
					data.ISANN=true;
					data.Title="Mail";
					data.Subject=advalue;
					break;
				case "OFF":
					data.Key=WEBACTION.UserKey+"_"+tkey;
					data.ISOFF=true;
					data.ISANN=true;
					data.Title="Offline Message";
					break;
				case "OFFANN":
					data.Key=WEBACTION.UserKey+"_"+tkey;
					data.ISANN=true;
					data.Title="Offline Announcement";
					data.ReceivedDate=advalue;
					break;
				case "OFFMAIL":
					data.Key=WEBACTION.UserKey+"_"+tkey;
					data.ISOFF=true;
					data.ISANN=true;
					data.Title="Offline Mail";
					data.Subject=advalue;
					break;
			}
			var gc=GroupCollection.getGroup(key);
			if(gc) {
				data.ISGC=true;
				data.Title="Group Chat";
				data.GCKey=key;
				var g=WEBACTION.getGCDataObject();
				g.GroupName=WEBACTION.getGroupName(WEBACTION.UserKey);
				g.GCUsers[g.GCUsers.length]={ UserKey: WEBACTION.UserKey,DisplayName: WEBACTION.getDisplayName(WEBACTION.UserKey) }
				data.Groups[data.Groups.length]=g;
				$.each(gc,function (i,uname) {
					var gname=WEBACTION.getGroupName(uname);
					if(gname!="") {
						var group=null;
						$.each(data.Groups,function (i,g) {
							if(g.GroupName==gname)
								group=g;
						});
						if(group==null) {
							var g=WEBACTION.getGCDataObject();
							g.GroupName=gname;
							g.GCUsers[g.GCUsers.length]={ UserKey: uname,DisplayName: WEBACTION.getDisplayName(uname) }
							data.Groups[data.Groups.length]=g;
						} else {
							group.GCUsers[group.GCUsers.length]={ UserKey: uname,DisplayName: WEBACTION.getDisplayName(uname) }
						}
					}
				});
			}
			WEBACTION.appendWindow(data);
		} catch(e) {
			alert("displayChatMessage:"+e);
		}
	}
	,clearSelectUser: function (userkey) {
		WEBACTION.getUserLI(userkey).remove();
		//WEBACTION.removeGC(userkey);
		var user=UserCollection.getUser(userkey);
		if(user) {
			var data=WEBACTION.getUserDataObject();
			data.UserKey=user.UserKey;
			data.DisplayName=user.DisplayName;
			data.GroupName=user.GroupName;
			data.UserStatus=user.UserStatus;
			data.Gender=user.Gender;
			data.PersonalStatus=user.PersonalStatus;
			WEBACTION.displayUser(data);
		}
		WEBACTION.calcCount();
	}
	,appendWindow: function (data) {
		try {
			switch(data.Mode) {
				case "ANN":
				case "MAIL":
				case "OFF":
				case "OFFANN":
				case "OFFMAIL":
					_otherWindowIndex++;
					var pageId="other-window-"+_otherWindowIndex;
					data.Index=_otherWindowIndex;
					var bdy=$("body");
					$.tmpl("otherwindowtemplate",data).appendTo(bdy);
					//$("#otherwindowtemplate").tmpl(data).appendTo(bdy);
					var $page=$("#"+pageId);
					$page.attr("isnewmessage","true");
					//WEBACTION.changePage($page,pageId);
					if($page.hasClass("ui-page-active")) {
						$page.attr("isnewmessage","false");
					}
					WEBACTION.displayNewMessageCnt($page);
					WEBACTION.changeCWCount();
					break;
				default:
					if(data.ISGC==false) {
						var user=UserCollection.getUser(data.FromName);
						if(user) {
							WEBACTION.chat(user.Index,true);
							var cw=$("#chat-window-"+user.Index);
							var content=$("div[data-role='content']",cw);
							cw.attr("isnewmessage","true");
							cw.attr("isclose","false");
							WEBACTION.appendMessage(content,data,"usermessagetemplate");
							if(cw.hasClass("ui-page-active")) {
								cw.attr("isnewmessage","false");
								$("div[isnew='true']",cw).attr("isnew","false");
							}
							WEBACTION.displayNewMessageCnt(cw);
							WEBACTION.changeCWCount();
						}
					} else {
						var $gcw=WEBACTION.createGCWindow(data.GCKey);
						var content=$("div[data-role='content']",$gcw);
						$gcw.attr("isnewmessage","true");
						$gcw.attr("isclose","false");
						WEBACTION.appendMessage(content,data,"usermessagetemplate");
						//WEBACTION.changePage($gcw,$gcw.attr("id"));
						if($gcw.hasClass("ui-page-active")) {
							$gcw.attr("isnewmessage","false");
							$("div[isnew='true']",$gcw).attr("isnew","false");
						}
						WEBACTION.displayNewMessageCnt($gcw);
						WEBACTION.changeCWCount();
					}
					break;
			}
		} catch(e) {
			alert("appendWindow:"+e);
		}
	}
	,hideGroup: function (that) {
		$.mobile.fixedToolbars.show(true);
		var groupname=$(that).attr("gcname");
		var ishide=$(that).attr("ishide");
		if(ishide=="false") {
			ishide="true";
			$(".ui-icon-arrow-d",that)
			.removeClass("ui-icon-arrow-d")
			.addClass("ui-icon-arrow-r")
			;
		} else {
			ishide="false";
			$(".ui-icon-arrow-r",that)
			.removeClass("ui-icon-arrow-r")
			.addClass("ui-icon-arrow-d")
			;
		}
		$(that).attr("ishide",ishide);
		$(".user_detail").each(function () {
			var usergroupname=$(this).attr("usergroupname");
			if(usergroupname==groupname) {
				if(ishide=="false") {
					$(this).show();
				} else {
					$(this).hide();
				}
			}
		});
	}
	,displayNewMessageCnt: function (page) {
		try {
			var pageId=$(page).attr("id");
			var cnt=getNewMsgCount(pageId);
			var h="";
			if(cnt>0) {
				h=cnt;
			}
			$("span[statusWindowId='"+pageId+"']").html(h);
		} catch(e) {
		}
	}
	,appendMessage: function (content,data,templatename) {
		var lastMessage=$(".msg:last",content);
		data.AppendUserKey=true;
		if(lastMessage.get(0)) {
			if(lastMessage.attr("msguserkey")==data.FromName) {
				data.AppendUserKey=false;
			}
		}
		if(!data.ISANN) {
			data.ISANN=false;
		}
		if(!data.ISOFF) {
			data.ISOFF=false;
		}
		if(data.ISANN) {
			data.FromName=WEBACTION.getDisplayName(data.FromName);
		}
		if(data.Message=="BUZZ!") {
			data.Message="<span class='BUZZ'>"+data.Message+"</span>";
		}
		if(data.DisplayName==""||data.DisplayName==undefined) {
			data.DisplayName=data.FromName;
		}
		if(data.Title==""||data.Title==undefined) {
			data.Title=data.DisplayName;
		}
		if(data.FromName==""||data.FromName==undefined&&data.DisplayName!="") {
			data.FromName=data.DisplayName;
		}
		if(isME(data.FromName)==false) {
			var totmsg=parseInt($("#hdntmcnt",content).val());
			totmsg+=1;
			$("#hdntmcnt",content).val(totmsg);
			WEBACTION.lastTitle=data.DisplayName+" messaged to you.";
		}
		WEBACTION.animateTitle();
		var msgcontainer=$(".msg-container",content);
		$.tmpl(templatename,data).appendTo(msgcontainer);
		//$("#"+templatename).tmpl(data).appendTo(content);
		var msgcontainer=$(".msg-container",content);
		WEBACTION.scrollObj(msgcontainer);
		$.mobile.fixedToolbars.show(true);
	}
	,changeGroupName: function (key,newname) {
		try {
			var user=UserCollection.getUser(key);
			if(user) {
				user.GroupName=newname;
			}
		} catch(ex) {
			alert("changeGroupName:"+ex);
		}
	}
	,changeStatus: function (key,status) {
		try {
			var user=UserCollection.getUser(key);
			if(user) {
				user.OMStatus=status;
			}
			var liuser=$("li[liuserkey='"+key+"']");
			if(liuser.get(0)) {
				var s=user.DisplayName;
				if($.trim(user.OMStatus)!="") {
					s+="&nbsp;("+user.OMStatus+")";
				}
				$("h3",liuser).html(s);
			}
		} catch(e) {
			alert("changeStatus:"+e);
		}
	}
	,scrollObj: function (target) {
		var t=$(target).get(0);
		if(t) {
			var cnt=$(t).parents("div[data-role='content']");
			if(cnt.height()<$(t).height()) {
				cnt.height($(t).height());
			}
			t.scrollTop=t.scrollHeight;
			$.mobile.silentScroll(t.scrollHeight);
		}
	}
	,animateTitle: function () {
		var m="";
		if(document.title=="OM") {
			m=WEBACTION.lastTitle;
		} else {
			m="OM";
		}
		if(m==""||m==null) {
			m="OM";
		}
		document.title=m;
	}
	,appendGCUser: function (data,groupName,userKey,nickName,key) {
		try {
			var g;
			var i;var isGroupExist=false;
			for(i=0;i<data.Groups.length;i++) {
				if(data.Groups[i].GroupName==groupName) {
					g=data.Groups[i];
					isGroupExist=true;
					break;
				}
			}
			if(isGroupExist==false) {
				g={ "GroupName": groupName,GCUsers: new Array() };
				data.Groups[data.Groups.length]=g;
			}
			WEBACTION.appendUser(g,userKey,nickName,key);
		} catch(e) {

		}
	}
    ,appendUser: function (data,userKey,nickName,key) {
    	try {
    		if(!(data.GCUsers)) { data.GCUsers=new Array(); }
    		data.GCUsers[data.GCUsers.length]={ UserKey: userKey,DisplayName: nickName };
    		GroupCollection.addUser(key,userKey);
    	} catch(e) {
    	}
    }
	,getCWDataObject: function () {
		var data={};
		data.Message="";
		data.DisplayName="";
		data.ME=false;
		data.Groups=new Array();
		data.ISGC=false;
		data.ISANN=false;
		data.ISOFF=false;
		data.GroupName="";
		data.FromName="";
		data.ToName="";
		data.GCKey="";
		data.Key="";
		data.SessionKey=WEBACTION.EncKey;
		data.Emotions=_Emotions;
		data.Title="";
		data.ReceivedDate="";
		data.Subject="";
		data.Mode="";
		return data;
	}
	,getGCDataObject: function () {
		return { GroupName: "",GCUsers: new Array() }
	}
	,getUserDataObject: function () {
		return { "Gender": "","GroupName": "","DisplayName": "","PersonalStatus": "","Type": "User","UserKey": "","UserStatus": "" };
	}
	 ,getDisplayName: function (userkey) {
	 	var nickName="";
	 	try {
	 		nickName=UserCollection.getUser(userkey).DisplayName;
	 	} catch(e) { }
	 	return nickName;
	 }
	,getGroupName: function (userkey) {
		var groupName="";
		try {
			groupName=UserCollection.getUser(userkey).GroupName;
		} catch(e) { }
		return groupName;
	}
	,changePersonalStatus: function (key,status) {
		try {
			var user=UserCollection.getUser(key);
			if(user) {
				user.PStatus=status;
			}
			var user=$(".pstatus[userkey='"+key+"']");
			user.empty();
			if($.trim(status)!="") {
				user.html(status);
				user.attr("title",status);
			}
		} catch(e) {
		}
	}
}
$.extend(window,{
	formatMessage: function (m) {
		try {
			m=m.replace(/\n/g,'<br/>');
			$.each(_Emotions,function (i,emo) {
				var li='<img src="images/'+emo.img+'" title="'+emo.tt+'" class="memo" />';
				var exp=emo.sym;
				if(emo.regExp) {
					exp=emo.regExp;
				}
				try {
					var e1="m=m.replace(/"+exp+"/g,'"+li+"');";
					if(emo.img=="no.gif") { m=m.replace(/:\^\)/g,li); }
					if(emo.img=="spit.gif") { m=m.replace(/:-#/g,li); }
					eval(e1);
				} catch(f) {
				}
			});
			var d=$("<div>"+m+"</div>");
			$("a",d).attr("target","_blank");
			return d.html();
		} catch(e) {
			return m;
		}
	}
    ,isME: function (userkey) {
    	return (userkey==WEBACTION.UserKey);
    }
    ,getSessionKey: function () {
    	return WEBACTION.EncKey;
    }
});
var _Emotions=[
            { sym: ":-)",tt: "Smile",img: "spin.gif",regExp: ":-\\)" }
            ,{ sym: ":-o",tt: "Surprise",img: "eyebrow.gif" }
            ,{ sym: ":-s",tt: "Confused",img: "boggled.gif" }
            ,{ sym: ":')",tt: "Crying",img: "weeping.gif",regExp: ":\\'\\)" }
            ,{ sym: "(h)",tt: "Hot",img: "hot.gif",regExp: "\\(h\\)" }
            ,{ sym: "|-)",tt: "Sleepy",img: "angel.gif",regExp: "\\|-\\)" }
            ,{ sym: ":-*",tt: "Secret telling",img: "shhh.gif",regExp: ":-\\*" }
            ,{ sym: ":^)",tt: "I don't know",img: "no.gif" }
            ,{ sym: ":o)",tt: "Party",img: "party.gif",regExp: ":o\\)" }
            ,{ sym: "(a)",tt: "Faint",img: "faint.gif",regExp: "\\(a\\)" }
            ,{ sym: ":p",tt: "Tongue Out",img: "yummy.gif" }
            ,{ sym: ":(",tt: "Sad",img: "indifferent.gif",regExp: ":\\(" }
            ,{ sym: "(d)",tt: "Devil",img: "devil.gif",regExp: "\\(d\\)" }
            ,{ sym: "+o(",tt: "Sick",img: "fever.gif",regExp: "\\+o\\(" }
            ,{ sym: "*-)",tt: "Thinking",img: "scratchchin.gif",regExp: "\\*-\\)" }
            ,{ sym: "-w)",tt: "Weeping",img: "crying.gif",regExp: "-w\\)" }
            ,{ sym: "-h)",tt: "HeadAche",img: "headache.gif",regExp: "-h\\)" }
            ,{ sym: ":w)",tt: "What",img: "drool.gif",regExp: ":w\\)" }
            ,{ sym: "-i)",tt: "Idea",img: "idea.gif",regExp: "-i\\)" }
            ,{ sym: "-c)",tt: "Clever",img: "shy.gif",regExp: "-c\\)" }
            ,{ sym: ":s)",tt: "Sorry",img: "sorry.gif",regExp: ":s\\)" }
            ,{ sym: ":-#",tt: "Don't tell everyone",img: "spit.gif" }
            ,{ sym: "-t)",tt: "TapedShut",img: "tapedshut.gif",regExp: "-t\\)" }
            ,{ sym: ";w)",tt: "Whistle",img: "whistleblower.gif",regExp: "\\;w\\)" }
            ,{ sym: ":)",tt: "Smile",img: "spin.gif",regExp: ":\\)" }
            ];
$.extend(window,{
	getTime: function (checkLast) {
		var currentTime=new Date();
		var hours=currentTime.getHours();
		var minutes=currentTime.getMinutes();
		var seconds=currentTime.getSeconds();
		var suffix="AM";
		if(hours>=12) {
			suffix="PM";
			hours=hours-12;
		}
		if(hours==0) {
			hours=12;
		}
		if(minutes<10) {
			minutes="0"+minutes;
		}
		if(seconds<10) {
			seconds="0"+seconds;
		}
		var t=hours+":"+minutes+" "+suffix;
		if(checkLast==true) {
			var lt=$(".time:last").html();
			if($.trim(lt)==t) {
				return "";
			} else {
				return t;
			}
		} else {
			return t;
		}
	}
	,getNewMsgCount: function (id) {
		var $page=$("#"+id);
		var cnt=$("div[isnew='true']",$page).length;
		if(isNaN(cnt)) {
			cnt=0;
		}
		return cnt;
	}
	,getNewMsgHtml: function (id) {
		var html="";
		var cnt=getNewMsgCount(id);
		if(cnt>0) {
			html+="<span id='cwmsgcnt' class='ui-li-count'><span class='ui-li-count' statusWindowId='"+id+"'>"+cnt+"</span></span>";
		}
		return html;
	}
	,getSessionKey: function () {
		return WEBACTION.EncKey;
	}
});
